#ifndef VIEWCONTROL_H
#define VIEWCONTROL_H

#include <QObject>
#include <QDebug>
#include <QTimer>
#include <QDesktopWidget>
#include <QApplication>
#include <QFile>
#include <QStandardPaths>
#include "controller/Interaction.h"
#include "view/horscreen/horscreen.h"
#include "view/verscreen/verscreen.h"

class viewControl : public QObject
{
    Q_OBJECT
public:
    viewControl();
    void initCore(const QStringList &list, bool isStart);//初始化后端
    QWidget *activeWindow();//返回当前窗口-横/竖
private:
    horscreen *m_horscreen = nullptr;
    verscreen *m_verscreen = nullptr;
    bool m_screen = false;//false-横屏，true-竖屏
    bool m_autoStart = false;//默认为开机自启，不显示主界面
    bool m_isStart = true;//默认为不带showmainwindow启动
    void showView(bool isStart);//实例化前端
    void showInCenter(QWidget *w);//显示在屏幕中央
    void initConnect();//信号槽
public slots:
    void autoStart();//通知实例化界面
    void toShowView();//在界面打开之后，将界面展示在屏幕中间---暂时没有用到，之后横竖屏会用到
signals:
    void setActiveWidow(QWidget *w);//通知激活窗口
};

#endif // VIEWCONTROL_H
