#include "viewvar.h"
#include <QDebug>

ViewVar * ViewVar::m_viewVar(nullptr);

ViewVar *ViewVar::getInstance()
{
    if (m_viewVar == nullptr) {
        m_viewVar = new ViewVar;
    }
    return m_viewVar;
}

//热门城市列表
QMap<int, QStringList > ViewVar::HOTCITY_MAP =ViewVar::saveHotCity();//热门城市列表
//城市item--收藏和搜索
QColor ViewVar::s_colorItem = QColor(120, 120, 120);
QColor ViewVar::s_colorWid = QColor(246, 246, 246,0);
QColor ViewVar::s_colorSearch = QColor(246, 246, 246,1);
const QSize ViewVar::COLLECT_BTNSIZE = QSize(36,36);//收藏城市按钮大小
//按钮位置
const int ViewVar::COLLECT_BTNXL = 155;
const int ViewVar::COLLECT_BTNYL = 4;
const int ViewVar::COLLECT_BTNXR = -10;
const int ViewVar::COLLECT_BTNYR = -8;
//文字位置
const int ViewVar::COLLECT_NAMEXL = 4;
const int ViewVar::COLLECT_TMPXL = 120;
const int ViewVar::COLLECT_CODEXL = 65;
//文字位置-same
const int ViewVar::COLLECT_SAMEYL = 4;
const int ViewVar::COLLECT_SAMEXR = -4;
const int ViewVar::COLLECT_SAMEYR = -4;
//图标位置
const int ViewVar::COLLECT_ICONXL = 80;
const int ViewVar::COLLECT_ICONYL = 4;
const int ViewVar::COLLECT_ICONXR = -144;
const int ViewVar::COLLECT_ICONYR = -6;
//按钮位置
const int ViewVar::SEARCH_BTNXL = 120;
const int ViewVar::SEARCH_BTNYL = 4;
const int ViewVar::SEARCH_BTNXR = -10;
const int ViewVar::SEARCH_BTNYR = -10;
//文字位置
const int ViewVar::SEARCH_NAMEXL = 4;
const int ViewVar::SEARCH_NAMEYL = 4;
const int ViewVar::SEARCH_NAMEXR = -4;
const int ViewVar::SEARCH_NAMEYR = -4;
const QString ViewVar::COLLECT_ICONPATH = QString(":/res/weather-icon/PNG16/2x/");
const QString ViewVar::COLLECT_ICONSUFFIX = QString(".png");//图标后缀
QPen ViewVar::m_collectPen = QPen(Qt::black);

const QRect ViewVar::COLLECT_ITEMRECT = QRect(0,0,170,170);//收藏城市item位置
const QRect ViewVar::SEARCH_ITEMRECT = QRect(0,0,170,170);//收藏城市item位置
const qreal ViewVar::SAME_ITEMRADIUS = 6;//收藏和搜索列表城市item圆角
//透明度设置
const qreal ViewVar::SAME_OPACITY_0 = 0;
const qreal ViewVar::SAME_OPACITY_1 = 0.2;
const qreal ViewVar::SAME_OPACITY_2 = 1;

bool ViewVar::s_themeStyle = true;//默认浅色
//收藏
const QSize ViewVar::COLLECT = QSize(595,141);
const QSize ViewVar::COLLECT_LIST = QSize(580,115);
const QPoint ViewVar::COLLECT_TITLE = QPoint(8,0);
const int ViewVar::NONECITYX = 10;
const int ViewVar::CITYLISTX = 14;
const int ViewVar::COLLECT_ITEMH = 36;
const int ViewVar::COLLECT_ITEMW = 185;
//热门
const QSize ViewVar::HOT = QSize (595,128);//热门
const QSize ViewVar::HOT_LIST = QSize (595,98);//热门城市列表
const QPoint ViewVar::HOT_TITLE = QPoint (8,0);//热门-title
const int ViewVar::HOTLISTX = 0;//热门城市list x值
const int ViewVar::ITEM_LENGTHM = 2;//热门城市文字长度最大值
const int ViewVar::ITEM_NUM = 8;//热门城市每行数量
const int ViewVar::ITEM_NUMM = 17;//热门城市每行数量
const int ViewVar::ITEM_POS = (46 +17);//热门城市item的间隔值
const int ViewVar::ITEM_DIS0 = 9;//热门城市个数值-行1
const int ViewVar::ITEM_DIS2 = 18;//热门城市个数值-行2
//热门-按钮大小
const QSize ViewVar::HOT_BTN = QSize (79,28);
//搜索框
const QSize ViewVar::SEARCH_BOX = QSize (244, 36);
//搜索框文本间距--左上右下
const QMargins ViewVar::SEARCH_MARGINS = QMargins (34,0,0,0);
//搜索框-图标控件大小
const QSize ViewVar::SEARCH_ICON = QSize (16,16);
//搜索框-图标位置-x
const int ViewVar::SEARCH_ICON_X0 = 97 - 8;
const int ViewVar::SEARCH_ICON_X1 = 9;

//搜索列表-个尺寸大小
const QSize ViewVar::SEARCH_LIST = QSize (538,287);
const int ViewVar::SEARCH_ITEMH = 41;//搜索城市item height值
const int ViewVar::SEARCH_ITEMW = 170;//搜索城市item weight值
const int ViewVar::SEARCH_NONEW = 500;//搜索城市无city的控件宽度值
//搜索-收藏-总界面
const QSize ViewVar::SEARCH = QSize (610,350);
//搜索框位置-y值
const int ViewVar::SEARCH_BOXY = 8;
const QPoint ViewVar::SEARCHLIST_POS = QPoint (46,54);//搜索列表位置
const int ViewVar::SEARCH_CHANGECITYX = 8;
const int ViewVar::DISTANCE0 = 10;//间隔0--热门和收藏的相互间距
const int ViewVar::DISTANCE1 = 16;//间隔1--热门和收藏与搜索框的相互间距

QGSettings * ViewVar::m_gsettingThemeData = ViewVar::getSettings();

QStringList ViewVar::hotMap(QString city, QString cityId)
{
    QStringList hotcity;
    hotcity.append(city);
    hotcity.append(cityId);
    return hotcity;
}

QMap<int,QStringList> ViewVar::saveHotCity()
{
    QMap<int,QStringList> hotcity;

    hotcity.insert(0,hotMap(tr("Beijing"),"101010100"));
    hotcity.insert(1,hotMap(tr("Shanghai"),"101020100"));
    hotcity.insert(2,hotMap(tr("Guangzhou"),"101280101"));
    hotcity.insert(3,hotMap(tr("Shenzhen"),"101280601"));
    hotcity.insert(4,hotMap(tr("Chengdu"),"101270101"));
    hotcity.insert(5,hotMap(tr("Wuhan"),"101200101"));
    hotcity.insert(6,hotMap(tr("Chongqing"),"101040100"));
    hotcity.insert(7,hotMap(tr("Hangzhou"),"101210101"));
    hotcity.insert(8,hotMap(tr("Nanjing"),"101190101"));
    hotcity.insert(9,hotMap(tr("Taibei"),"101340101"));
    hotcity.insert(10,hotMap(tr("Suzhou"),"101190401"));
    hotcity.insert(11,hotMap(tr("Tianjin"),"101030100"));
    hotcity.insert(12,hotMap(tr("Qingdao"),"101120201"));
    hotcity.insert(13,hotMap(tr("Changsha"),"101250101"));
    hotcity.insert(14,hotMap(tr("Zhengzhou"),"101180101"));
    hotcity.insert(15,hotMap(tr("Xian"),"101110101"));
    hotcity.insert(16,hotMap(tr("Wuxi"),"101190201"));
    hotcity.insert(17,hotMap(tr("Jinan"),"101120101"));
    hotcity.insert(18,hotMap(tr("Hongkong"),"101320101"));
    hotcity.insert(19,hotMap(tr("Macao"),"101330101"));//Macao
    hotcity.insert(20,hotMap(tr("Lasa"),"101140101"));
    hotcity.insert(21,hotMap(tr("Lijiang"),"101291401"));
    return hotcity;
}
//主题深浅模式
QGSettings *ViewVar::getSettings()
{
    m_gsettingThemeData = nullptr;
    if (QGSettings::isSchemaInstalled(FITTHEMEWINDOW)) {
        m_gsettingThemeData = new QGSettings(FITTHEMEWINDOW);
        connect(m_gsettingThemeData, &QGSettings::changed,&ViewVar::monitorGsetting);
    }
    monitorGsetting();
    return m_gsettingThemeData;
}
int i = 0;
//监听主题配置文件
void ViewVar::monitorGsetting()
{
    QString themeStyle = m_gsettingThemeData->get("styleName").toString();
    if ("ukui-dark" == themeStyle || "ukui-black" == themeStyle) {
        ViewVar::s_colorItem = QColor(255, 255, 255,255*0.6);
        ViewVar::s_colorWid = QColor(0,0,0,0);
        ViewVar::s_colorSearch = QColor(0,0,0,1);
        ViewVar::m_collectPen = QPen(Qt::white);
        s_themeStyle = false;
    } else {
        ViewVar::s_colorItem = QColor(120, 120, 120);
//        ViewVar::s_colorWid = QColor(246,246,246,0);
//        ViewVar::s_colorSearch = QColor(246,246,246,1);
        ViewVar::s_colorWid = QColor(255,255,255,0);
        ViewVar::s_colorSearch = QColor(255,255,255,1);
        ViewVar::m_collectPen = QPen(Qt::black);
        s_themeStyle = true;
    }
    emit ViewVar::getInstance()->monitorThemeChanged(themeStyle);
}
