#include "air.h"
#include <QVBoxLayout>
#include <QGraphicsOpacityEffect>
#define UKUI_STYLE "org.ukui.style"
#define UKUI_FONT_SIZE "systemFontSize"
air::air(QWidget *parent) : QWidget(parent)
{
    m_airLayout = new QVBoxLayout(this);

    m_airIcon = new QLabel(this);
    m_str = new QLabel(this);
    m_degree = new QLabel(this);

    QPixmap airpixmap(":/res/contorl_icons/index_air.png");
    m_airIcon->setPixmap(airpixmap);

    m_str->setText(tr("Air"));

    m_degree->setText(tr("N/A"));

    initLayout();
//    initQss();
}

void air::setItemContent(QString text)
{
    m_degree->setText(text);
}

void air::isFullScreen(int m_isFullScreen)
{
    m_judgeFullScreen = m_isFullScreen;
    initQss(14.0);
}

void air::initLayout()
{
    m_airLayout->addWidget(m_airIcon);
    m_airLayout->addWidget(m_str);
    m_airLayout->addWidget(m_degree);
}

void air::lable2SetFontSizeSlot(int size)
{
    //默认大小12px,换算成pt为9
    double lable2BaseFontSize = 11;//魔鬼数字，自行处理
    double nowFontSize = lable2BaseFontSize * double(size) / 11;//11为系统默认大小，魔鬼数字，自行处理
//    QFont font;
//    font.setPointSizeF(nowFontSize);
//    ui->label2->setFont(font);
    initQss(nowFontSize);
}

void air::initFontSize()
{
    //只有非标准字号的控件才需要绑定
    connect(this,&air::setFontSizeSignal,this,&air::lable2SetFontSizeSlot);

    //判断gsettings是否存在
    if(QGSettings::isSchemaInstalled(UKUI_STYLE)) {
        m_fontSize = new QGSettings(UKUI_STYLE);
        //监听系统字号大小改变事件
        connect(m_fontSize,&QGSettings::changed,this, [=] (const QString &key) {
            if(key == UKUI_FONT_SIZE) {
                //获取字号的值
                int fontSizeKey = m_fontSize->get(UKUI_FONT_SIZE).toString().toInt();
                //发送改变信号
                if (fontSizeKey > 0) {
                    emit setFontSizeSignal(fontSizeKey);
                }
            }
        });
    }
    //启动时设置字号
    int fontSizeKey = 11;//系统默认字号,魔鬼数字，自行处理
    if (m_fontSize != nullptr) {
        int fontSizeKeyTmp = m_fontSize->get(UKUI_FONT_SIZE).toString().toInt();
        if (fontSizeKeyTmp > 0) {
            fontSizeKey = fontSizeKeyTmp;
        }
    }
    emit setFontSizeSignal(fontSizeKey);
}

void air::initQss(double nowFontSize)
{
    m_airIcon->setAlignment(Qt::AlignCenter);

    if(m_judgeFullScreen == 0){
        m_airIcon->resize(30,30);
        QPixmap airpixmap(airpath);
        m_airIcon->setPixmap(airpixmap);

        //    m_str->setStyleSheet("font:14px;color:white;");
        QFont m_font;
//        m_font.setPointSizeF(nowFontSize);
        m_str->setFont(m_font);
        m_str->setAlignment(Qt::AlignCenter);
        QPalette airStrPalette = m_str->palette();
        airStrPalette.setColor(QPalette::WindowText,Qt::white);
        m_str->setPalette(airStrPalette);
        //    设置字体透明度
        QGraphicsOpacityEffect *strOpacityEffect=new QGraphicsOpacityEffect;
        strOpacityEffect->setOpacity(0.7);
        m_str->setGraphicsEffect(strOpacityEffect);
        //    m_degree->setStyleSheet("font:14px;color:white;");
        m_degree->setAlignment(Qt::AlignCenter);
        QPalette airDegreePalette = m_degree->palette();
        airDegreePalette.setColor(QPalette::WindowText,Qt::white);
        m_degree->setPalette(airDegreePalette);
        m_degree->setFont(m_font);
    }
    else {
        m_airIcon->resize(60,60);
        QPixmap airpixmap(airpath);
        airpixmap = airpixmap.scaled(m_airIcon->width(),m_airIcon->height(),Qt::KeepAspectRatio, Qt::SmoothTransformation);
        m_airIcon->setPixmap(airpixmap);
        QFont m_font;
        m_font.setPixelSize(28);
        m_str->setFont(m_font);
        m_degree->setFont(m_font);
    }
}
