#include "city.h"
#include <QHBoxLayout>
#include <QThread>
#include <QGraphicsOpacityEffect>
extern double detio;
city::city(QWidget *parent) : QWidget(parent)
{
    this->setAttribute(Qt::WA_TranslucentBackground);
    m_cityLayout = new QHBoxLayout(this);

    m_centrlWid = new QWidget(this);
    m_centrlWid->setFixedSize(900, this->height());

    m_cityWidgetLayout = new QHBoxLayout(m_centrlWid);
    m_leftLayout = new QHBoxLayout();
    m_rightLayout = new QVBoxLayout();
    m_cityAndChangeLayout = new QHBoxLayout();
    m_iconAndWeatherLayout = new QHBoxLayout();
    m_humidityAndWindLayout = new QHBoxLayout();

    m_temperatureNum = new QLabel(m_centrlWid);
    m_degreeNotation = new QLabel(m_centrlWid);
    m_curCity = new QLabel(m_centrlWid);
    m_changeCityBtn = new QPushButton(m_centrlWid);
    m_changeCityBtn->setEnabled(false);
    m_weatherPicture = new QLabel(m_centrlWid);
    m_weather = new QLabel(m_centrlWid);
    m_humidity = new QLabel(m_centrlWid);
    //    m_humidity->setFixedSize(200,30);
    m_windForce = new QLabel(m_centrlWid);
    //    m_windForce->setFixedSize(200,30);

    //    m_cityWidgetLayout->addWidget(m_temperatureNum);
    //    m_cityWidgetLayout->addWidget(m_degreeNotation);
    m_leftLayout->addWidget(m_temperatureNum);
    m_leftLayout->addWidget(m_degreeNotation);
    m_cityWidgetLayout->addLayout(m_leftLayout);
    m_cityWidgetLayout->addLayout(m_rightLayout, Qt::AlignCenter);
    m_rightLayout->addLayout(m_cityAndChangeLayout);
    m_rightLayout->addLayout(m_iconAndWeatherLayout);
    m_rightLayout->addLayout(m_humidityAndWindLayout);

    m_cityAndChangeLayout->addStretch(0);
    m_cityAndChangeLayout->addWidget(m_curCity);
    m_cityAndChangeLayout->addStretch(1);
    m_cityAndChangeLayout->addWidget(m_changeCityBtn);
    m_cityAndChangeLayout->addStretch(8);

    m_iconAndWeatherLayout->addStretch(0);
    m_iconAndWeatherLayout->addWidget(m_weatherPicture);
    m_iconAndWeatherLayout->addStretch(4);
    m_iconAndWeatherLayout->addWidget(m_weather);
    m_iconAndWeatherLayout->addStretch(80);

    m_humidityAndWindLayout->addStretch(0);
    m_humidityAndWindLayout->addWidget(m_humidity);
    //    m_humidityAndWindLayout->addSpacing(40);
    m_humidityAndWindLayout->addStretch(1);
    m_humidityAndWindLayout->addWidget(m_windForce);
    m_humidityAndWindLayout->addStretch(40);

    m_temperatureNum->setText("≡");
    m_temperatureNum->setAlignment(Qt::AlignTop);

    m_degreeNotation->setText("°");
    m_degreeNotation->setAlignment(Qt::AlignTop);
    //    m_degreeNotation->setFixedSize(200,35);

    //    m_curCity->setFixedSize(100,35);
    m_curCity->setText("N/A");

    // 切换城市
    m_changeCityBtn->setFixedSize(75, 35);
    m_changeCityBtn->setText(tr("【Change】"));

    //天气图标
    path = ":/res/weather-icon/PNG16/2x/999.png";
    QPixmap pixmap(path);
    m_weatherPicture->setPixmap(pixmap);

    m_weather->setText("N/A");

    m_humidity->setText("N/A");

    m_windForce->setText("N/A");
}

void city::resizeEvent(QResizeEvent *event) {}

void city::getCurrentInfor(CurrentWeather m_currentWeather)
{
    code = m_currentWeather.cond_code;
    //天气图标
    path = ":/res/weather-icon/PNG16/2x/" + code + ".png";
    QPixmap pixmap(path);
    //    pixmap = pixmap.scaled(m_weatherPicture->width(), m_weatherPicture->height(), Qt::IgnoreAspectRatio,
    //    Qt::SmoothTransformation);
    m_weatherPicture->setPixmap(pixmap);

    if (m_currentWeather.tmp.length() == 1) {
        m_temperatureNum->setText("  " + m_currentWeather.tmp);
    } else {
        m_temperatureNum->setText("" + m_currentWeather.tmp);
    }

    m_curCity->setText(m_currentWeather.city);
    m_weather->setText(m_currentWeather.cond_txt);
    m_humidity->setText("湿度" + m_currentWeather.hum + "%");
    m_windForce->setText("" + m_currentWeather.wind_dir + m_currentWeather.wind_sc + "级");
}

void city::isFullScreen(int m_isFullScreen)
{
    m_judgeFullScreen = m_isFullScreen;
    initQss(m_judgeFullScreen);
}

void city::initConnect() {}

void city::initLayout(double detio)
{
    if (detio <= 1.0) {
        m_cityLayout->addWidget(m_centrlWid, Qt::AlignTop);
        this->setLayout(m_cityLayout);

        m_rightLayout->setContentsMargins(10, 40, 0, 10);
        m_weatherPicture->resize(36, 33);
        m_degreeNotation->setContentsMargins(0, 20, 0, 0);
        //        m_degreeNotation->setGeometry(m_temperatureNum->x()+m_temperatureNum->width(),m_temperatureNum->y()+80,21,27);
    } else {
        m_rightLayout->setContentsMargins(10 * detio, 40 * detio, 0, 10 * detio);
        m_weatherPicture->resize(36 * detio, 33 * detio);
        m_degreeNotation->setContentsMargins(0, 20 * detio, 0, 0);
        //        m_degreeNotation->setGeometry(m_temperatureNum->x()+m_temperatureNum->width(),m_temperatureNum->y()+40,42,54);
    }
}

void city::initQss(int m_judgeFullScreen)
{
    if (m_judgeFullScreen == 0) {
        //        m_temperatureNum->setStyleSheet("font:120px;color:white;");
        m_font.setPixelSize(120);
        m_temperatureNum->setFont(m_font);
        //    设置显示白色字体
        QPalette temperatureNumPalette = m_temperatureNum->palette();
        temperatureNumPalette.setColor(QPalette::WindowText, Qt::white);
        m_temperatureNum->setPalette(temperatureNumPalette);
        //        m_temperatureNum->setStyleSheet("{background-color:blue;}");

        //        m_degreeNotation->setStyleSheet("font:40px;color:white;");
        m_font.setPixelSize(60);
        m_degreeNotation->setFont(m_font);

        //    设置显示白色字体
        QPalette degreeNotationPalette = m_degreeNotation->palette();
        degreeNotationPalette.setColor(QPalette::WindowText, Qt::white);
        m_degreeNotation->setPalette(degreeNotationPalette);

        //        m_curCity->setStyleSheet("font:16px;color:white;");
        m_font.setPointSize(16);
        m_curCity->setFont(m_font);
        //    设置显示白色字体
        QPalette curCityPalette = m_curCity->palette();
        curCityPalette.setColor(QPalette::WindowText, Qt::white);
        m_curCity->setPalette(curCityPalette);

        //        m_changeCityBtn->setStyleSheet("QPushButton{color:rgba(255,255,255,0.8);border:none}"
        //                                       "QPushButton:Hover{color:#61ADFF;border:none}"
        //                                       "QPushButton:Pressed{color:#3790FA;border:none}");

        m_changeCityBtn->setStyleSheet("QPushButt"
                                       "on{color:rgba(255,255,255,0.8);border:none}"
                                       "QPushButton:Hover{color:rgba(255,255,255,1);border:none}"
                                       "QPushButton:Pressed{color:rgba(255,255,255,0.65);border:none}");

        m_weatherPicture->resize(36, 33);
        QPixmap pixmap(path);
        //        pixmap = pixmap.scaled(m_weatherPicture->width(), m_weatherPicture->height(), Qt::IgnoreAspectRatio,
        //        Qt::SmoothTransformation);
        m_weatherPicture->setPixmap(pixmap);

        //        m_weather->setStyleSheet("font:30px;color:white;");
        m_font.setPixelSize(30);
        m_weather->setFont(m_font);
        //    设置显示白色字体
        QPalette weatherPalette = m_weather->palette();
        weatherPalette.setColor(QPalette::WindowText, Qt::white);
        m_weather->setPalette(weatherPalette);

        //        m_humidity->setStyleSheet("color:rgba(255,255,255,0.7);");
        //    设置显示白色字体
        QPalette humidityPalette = m_humidity->palette();
        humidityPalette.setColor(QPalette::WindowText, Qt::white);
        m_humidity->setPalette(humidityPalette);
        QFont m_humidityAndWindForce;
        m_humidity->setFont(m_humidityAndWindForce);
        //    设置字体透明度
        QGraphicsOpacityEffect *humidityOpacityEffect = new QGraphicsOpacityEffect;
        humidityOpacityEffect->setOpacity(0.7);
        m_humidity->setGraphicsEffect(humidityOpacityEffect);

        //        m_windForce->setStyleSheet("color:rgba(255,255,255,0.7);");
        //    设置显示白色字体
        QPalette windForcePalette = m_windForce->palette();
        windForcePalette.setColor(QPalette::WindowText, Qt::white);
        m_windForce->setPalette(windForcePalette);
        //    设置字体透明度
        QGraphicsOpacityEffect *windForceOpacityEffect = new QGraphicsOpacityEffect;
        windForceOpacityEffect->setOpacity(0.7);
        m_windForce->setGraphicsEffect(windForceOpacityEffect);
        m_windForce->setFont(m_humidityAndWindForce);
    } else // 全屏界面
    {
        //        m_temperatureNum->setStyleSheet("font:120px;color:white;");
        m_font.setPixelSize(240);
        m_temperatureNum->setFont(m_font);
        //    设置显示白色字体
        QPalette temperatureNumPalette = m_temperatureNum->palette();
        temperatureNumPalette.setColor(QPalette::WindowText, Qt::white);
        m_temperatureNum->setPalette(temperatureNumPalette);
        m_temperatureNum->resize(300, 300);

        //        m_degreeNotation->setStyleSheet("font:40px;color:white;");
        m_font.setPixelSize(120);
        m_degreeNotation->setFont(m_font);
        //    设置显示白色字体
        QPalette degreeNotationPalette = m_degreeNotation->palette();
        degreeNotationPalette.setColor(QPalette::WindowText, Qt::white);
        m_degreeNotation->setPalette(degreeNotationPalette);

        //        m_curCity->setStyleSheet("font:16px;color:white;");
        m_font.setPixelSize(32);
        m_curCity->setFont(m_font);
        //    设置显示白色字体
        QPalette curCityPalette = m_curCity->palette();
        curCityPalette.setColor(QPalette::WindowText, Qt::white);
        m_curCity->setPalette(curCityPalette);

        //    m_changeCityBtn->setStyleSheet("font:14px;color:white;border:none");

        m_changeCityBtn->setStyleSheet("QPushButt"
                                       "on{color:rgba(255,255,255,0.8);border:none}"
                                       "QPushButton:Hover{color:rgba(255,255,255,1);border:none}"
                                       "QPushButton:Pressed{color:rgba(255,255,255,0.65);border:none}");
        //        m_changeCityBtn->setStyleSheet("QPushButton{color:white;border:none}"
        //                                       "QPushButton:Hover{color:#3E6CE5;border:none}"
        //                                       "QPushButton:Pressed{color:#4260C4;border:none}");

        m_weatherPicture->resize(72, 66);
        QPixmap pixmap(path);
        pixmap = pixmap.scaled(m_weatherPicture->width(), m_weatherPicture->height(), Qt::IgnoreAspectRatio,
                               Qt::SmoothTransformation);
        m_weatherPicture->setPixmap(pixmap);

        //        m_weather->setStyleSheet("font:30px;color:white;");
        m_font.setPixelSize(60);
        m_weather->setFont(m_font);
        //    设置显示白色字体
        QPalette weatherPalette = m_weather->palette();
        weatherPalette.setColor(QPalette::WindowText, Qt::white);
        m_weather->setPalette(weatherPalette);

        m_font.setPixelSize(28);
        m_humidity->setFont(m_font);
        //        m_humidity->setStyleSheet("color:rgba(255,255,255,0.7);");
        //    设置显示白色字体
        QPalette humidityPalette = m_humidity->palette();
        humidityPalette.setColor(QPalette::WindowText, Qt::white);
        m_humidity->setPalette(humidityPalette);
        //    设置字体透明度
        QGraphicsOpacityEffect *humidityOpacityEffect = new QGraphicsOpacityEffect;
        humidityOpacityEffect->setOpacity(0.7);
        m_humidity->setGraphicsEffect(humidityOpacityEffect);

        m_windForce->setFont(m_font);
        //        m_windForce->setStyleSheet("color:rgba(255,255,255,0.7);");
        //    设置显示白色字体
        QPalette windForcePalette = m_windForce->palette();
        windForcePalette.setColor(QPalette::WindowText, Qt::white);
        m_windForce->setPalette(windForcePalette);
        //    设置字体透明度
        QGraphicsOpacityEffect *windForceOpacityEffect = new QGraphicsOpacityEffect;
        windForceOpacityEffect->setOpacity(0.7);
        m_windForce->setGraphicsEffect(windForceOpacityEffect);
    }
}
