#ifndef HORSCREEN_H
#define HORSCREEN_H

#include <QWidget>
#include <QLabel>
#include <QIcon>
#include <QPushButton>
#include <QDebug>
#include <QResizeEvent>
#include <QScreen>
#include <QDBusInterface>
#include <QScrollArea>
#include "view/search/searchview.h"
#include "controller/Interaction.h"
#include "global/corevar.h"
#include "title.h"
#include "empty.h"
#include "city.h"
#include "information.h"
#include "daemondbus.h"
#include "promptwidget.h"
#include "view/horscreen/allowlocation.h"
class horscreen : public QWidget
{
    Q_OBJECT
public:
    explicit horscreen(QWidget *parent = nullptr);
    static horscreen *mutual;//指针类型静态成员变量
    static CurrentWeather *m_showCurrentWeather;
    void changeBackgroundImage(CurrentWeather m_currentWeather);
//    static bool isFullScreen = 1; // 判断是全屏还是普通界面，初始未启动下等同于全屏值为 1
    void showLocateWidget();
    void showAllowLocationWidget();
private:
    title *m_title = nullptr;
    Empty *m_empty = nullptr;
    city *m_city = nullptr;
    QVBoxLayout *m_mainLayout;
    QVBoxLayout *m_mainCityLayout = nullptr;
    QLabel *m_label;
    SearchView *m_searchView = nullptr;
    information *m_information;
    QScrollArea *m_scrollarea;
    QWidget *m_scrollwidget;
    DaemonDbus *m_DaemonIpcDbus;
    QWidget *m_networkErrorWidget = nullptr;
    PromptWidget *m_hintWidget = nullptr;
    AllowLocation *m_AllowLocationwidget = nullptr;
    QSystemTrayIcon *m_trayIcon = nullptr;
    QMenu *m_mainMenu = nullptr;
    QAction *m_openAction;
    QAction *m_quitAction;

    int m_isFullScreen = 1;
    bool isShow = false;  // 网络异常提示界面是否显示
    QString netErrorInfor="";
    // 判断前面是否有网导致界面显示出正常天气信息
    // 0 : 使用过网络； 1 : 未使用过(初始值为 1)
    int usedNet = 1;
    double detio = 1.0;
    // 饱满填充
    QPixmap m_pixmap;
//    bool m_searchShow = false;//默认搜索弹窗没有弹出--先保留
    void initInteraction();//后端初始化信号槽
    void initConnect();//初始化前端信号槽
    void resizeEvent(QResizeEvent *event);
    bool event(QEvent *event);//做searchView的失焦处理
    void changOrigSize();
    void initLayout();
    void changeHeight(double detio);
//    void mouseDoubleClickEvent(QMouseEvent *event);//双击响应--全屏和还原
    void keyPressEvent(QKeyEvent *event);// 键盘响应事件--f1
    QString getBackgroundImageName(QString code);
    void showNetworkErrorDialog(QString);

private slots:
    void hideSearchView();
    void showSearchView();
    void recieveNetSignal(QString netError);//接收网络错误信息
    void geoUiShow(QString geoError);
//    void recieveCityName(QString cityName);//接收网络错误信息
    void showCurrent(CurrentWeather m_currentWeather);//接收当前城市信息
    void showForcast(ForecastWeather forecastWeather);//接收预测信息
    void showLifeStyle(LifeStyle m_lifeStyle);//接收生活指数信息
    void showHourly(QVariant var);//接收逐小时信息
    void createTrayIcon(QString code);//创建托盘图标
    void handleIconClickedSub();//托盘图标被点击,显示在屏幕中央
//    void handleIconClicked();//处理点击托盘图标事件
    void iconActivated(QSystemTrayIcon::ActivationReason reason);
    void closeActivated();

signals:
    void sendCurrentInfor(CurrentWeather m_currentWeather);//
    void sendLifeStyleInfor(LifeStyle m_lifeStyle,int m_isFullScreen);
    void sendHourlyInfor(QList<Hourly> tmp_list , int m_isFullScreen); // 逐小时信息
    void sendIsFullScreen(int isFullScreen);
    void sendWeatherIconInfor(int isFullScreen);
    void sendIsFullScreenAndShow(int isFullScreen,bool isShow);
    void sendDetio(double detio);
    void sendForcastInfor(ForecastWeather m_forecastWeather,int m_isFullScreen);
    void loadCollectCity();//发送信号给后端--加载收藏城市列表
    void recallInitLayout(QString netErrorInfor,int m_isFullScreen);
    void searchClear();//当搜索隐藏时，发信号搜索界面，重置界面
    void showCenterAfter(); // 显示在屏幕中间
    void setCentralWidFixedSize(bool isFullScreen, double detio);//设置当前城市widget普通大小和全屏界面大小
    void changeLoadingIconToButton();
};

#endif // HORSCREEN_H
