#include "lifestyle.h"

lifestyle::lifestyle(QWidget *parent) : QWidget(parent)
{
    m_lifestyleLayout = new QHBoxLayout(this);

    m_ultravioletrays = new ultravioletrays(this);
    m_air = new air(this);
    m_sport = new sport(this);
    m_washcar = new washcar(this);
    m_flu = new flu(this);
    m_clothe = new clothe(this);

    initLayout();
    initConnect();
}

void lifestyle::getLifeStyleInfor(LifeStyle m_lifeStyle,int m_isFullScreen)
{
    m_ultravioletrays->setItemContent(m_lifeStyle.uv_brf);
    m_air->setItemContent(m_lifeStyle.air_brf);
    m_sport->setItemContent(m_lifeStyle.sport_brf);
    m_washcar->setItemContent(m_lifeStyle.cw_brf);
    m_flu->setItemContent(m_lifeStyle.flu_brf);
    m_clothe->setItemContent(m_lifeStyle.drsg_brf);
}

void lifestyle::initLayout()
{
    double m_radio = 1;
    m_lifestyleLayout->addStretch(4);
    m_lifestyleLayout->addWidget(m_ultravioletrays);
    m_lifestyleLayout->addStretch(3);
    m_lifestyleLayout->addWidget(m_air);
    m_lifestyleLayout->addStretch(3);
    m_lifestyleLayout->addWidget(m_sport);
    m_lifestyleLayout->addStretch(3);
    m_lifestyleLayout->addWidget(m_washcar);
    m_lifestyleLayout->addStretch(3);
    m_lifestyleLayout->addWidget(m_flu);
    m_lifestyleLayout->addStretch(3);
    m_lifestyleLayout->addWidget(m_clothe);
    m_lifestyleLayout->addStretch(4);
    m_lifestyleLayout->setContentsMargins(100*m_radio,0,115*m_radio,20);
    this->setLayout(m_lifestyleLayout);
}

void lifestyle::initConnect()
{
    connect(this,&lifestyle::sendIsFullScreen,m_ultravioletrays,&ultravioletrays::isFullScreen);
    connect(this,&lifestyle::sendIsFullScreen,m_air,&air::isFullScreen);
    connect(this,&lifestyle::sendIsFullScreen,m_sport,&sport::isFullScreen);
    connect(this,&lifestyle::sendIsFullScreen,m_washcar,&washcar::isFullScreen);
    connect(this,&lifestyle::sendIsFullScreen,m_flu,&flu::isFullScreen);
    connect(this,&lifestyle::sendIsFullScreen,m_clothe,&clothe::isFullScreen);
}
