#include "title.h"
#include "horscreen.h"

title::title(QWidget *parent) : QWidget(parent)
{
    m_titleLayout = new QHBoxLayout(this);
    logoBtn = new QPushButton(this);
    logoBtn->setFixedSize(24,24);//重置图标大小
//    logoBtn->setIcon(QIcon::fromTheme("kylin-weather", QIcon(":/res/contorl_icons/icon.png")));
    logoBtn->setIcon(QIcon::fromTheme("kylin-weather", QIcon(":/res/contorl_icons/icon.png")));
    logoBtn->setIconSize(QSize(24,24));
    logoBtn->setFocusPolicy(Qt::NoFocus);

    m_label = new QLabel(this);
    m_label->setText(tr("Weather"));
//    m_menuButton = new QPushButton(this);

    //窗口四联--菜单
    g_menu = new menuModule(this);
    g_menu->setFocusPolicy(Qt::NoFocus);
    g_menu->setAttribute(Qt::WA_TranslucentBackground);

    //菜单
//    m_menuButton = new QPushButton(this);
//    m_menuButton->setFocusPolicy(Qt::NoFocus);//设置焦点类型
//    m_menuButton->setToolTip(tr("menu"));
//    m_menuButton->setIcon(QIcon::fromTheme("open-menu-symbolic"));
//    m_menuButton->setIconSize(QSize(16,16));
//    QSize iconSize = QSize(24,24);
//    m_menuButton->setFixedSize(iconSize);

//    m_mainMenu = new QMenu;

//    QList<QAction *> actions;
//    QAction *actionHelp = new QAction(m_mainMenu);
//    actionHelp->setText(tr("Help"));
//    QAction *actionAbout = new QAction(m_mainMenu);
//    actionAbout->setText(tr("About"));
//    QAction *actionQuit = new QAction(m_mainMenu);
//    actionQuit->setText(tr("Quit"));
//    actions<<actionHelp<<actionAbout<<actionQuit;
//    m_mainMenu->addActions(actions);
//    m_menuButton->setMenu(m_mainMenu);
    //窗口四联--最小化按钮
    btnMinimize = new QPushButton(this);
    btnMinimize->setFixedSize(QSize(30,30));
    btnMinimize->setToolTip(tr("minimize"));
    btnMinimize->setFocusPolicy(Qt::NoFocus);//设置焦点类型
    btnMinimize->setIcon(QIcon::fromTheme("window-minimize-symbolic"));//主题库的最小化图标
    btnMinimize->setProperty("isWindowButton", 0x1);
    btnMinimize->setProperty("useIconHighlightEffect", 0x2);
    btnMinimize->setFlat(true);
    //窗口四联--最大化/还原按钮
    //全屏按钮注释代码
//    btnMaximum = new QPushButton(this);
//    btnMaximum->setIcon(QIcon::fromTheme("window-maximize-symbolic"));
//    btnMaximum->setFixedSize(QSize(30,30));
//    btnMaximum->setToolTip(tr("full screen"));
//    btnMaximum->setFocusPolicy(Qt::NoFocus);//设置焦点类型
//    btnMaximum->setProperty("isWindowButton", 0x1);
//    btnMaximum->setProperty("useIconHighlightEffect", 0x2);
//    btnMaximum->setFlat(true);
    //窗口四联--关闭按钮
    btnCancel = new QPushButton(this);
    btnCancel->setToolTip(tr("close"));
    btnCancel->setIcon(QIcon::fromTheme("window-close-symbolic"));
    btnCancel->setFixedSize(QSize(30,30));
    btnCancel->setFocusPolicy(Qt::NoFocus);//设置焦点类型
    btnCancel->setProperty("isWindowButton", 0x2);
    btnCancel->setProperty("useIconHighlightEffect", 0x8);
    btnCancel->setFlat(true);
//    btnCancel->setStyleSheet("QPushButton{border:0px;border-radius:4px;background:transparent;}"
//                             "QPushButton:Hover{border:0px;border-radius:4px;background:transparent;background-color:#F86457;}"
//                             "QPushButton:Pressed{border:0px;border-radius:4px;background:transparent;background-color:#E44C50;}");
//    btnCancel->setStyleSheet("QPushButton{border:0px;border-radius:4px;background:transparent;}"
//                             "QPushButton::hover{border:0px;border-radius:4px;background:transparent;}"
//                             "QPushButton::pressed{border:0px;border-radius:4px;background:transparent;}");

    this->initConnection();
    this->initLayout();
    this->initQss();
}

void title::initConnection()
{
    connect(btnMinimize, &QPushButton::clicked, horscreen::mutual,&horscreen::showMinimized);
//    connect(btnMaximum,&QPushButton::clicked,horscreen::mutual,&horscreen::showMaximized);
    connect(btnCancel,&QPushButton::clicked,horscreen::mutual,&horscreen::hide);
    //全屏按钮注释代码
//    connect(btnMaximum, &QPushButton::clicked, this, &title::recovery);

    connect(g_menu,&menuModule::aboutShow,this,&title::aboutShow);

    // 首次允许定位弹窗点击“是”更改菜单内允许定位为“是”
    connect(this,&title::setMenuModuleAllowLocationYes,g_menu,&menuModule::setMenuModuleAllowLocationYes);
}

void title::initLayout()
{
    m_titleLayout->addWidget(logoBtn);

    m_titleLayout->addSpacing(4);
    m_titleLayout->addWidget(m_label);

    m_titleLayout->addStretch();

//    m_titleLayout->addWidget(m_menuButton);
    m_titleLayout->addWidget(g_menu->menuButton);

    m_titleLayout->addWidget(btnMinimize);

    //全屏按钮注释代码
//    m_titleLayout->addWidget(btnMaximum);

    m_titleLayout->addWidget(btnCancel);
    m_titleLayout->setContentsMargins(4,4,4,0);
    this->setLayout(m_titleLayout);

}

void title::initQss()
{
    logoBtn->setStyleSheet("QPushButton{border:0px;border-radius:4px;background:transparent;}"
                           "QPushButton::hover{border:0px;border-radius:4px;background:transparent;}"
                           "QPushButton::pressed{border:0px;border-radius:4px;background:transparent;}");
////    m_menuButton->setStyleSheet("QPushButton{border:0px;border-radius:4px;background:transparent;}"
//     g_menu->menuButton->setStyleSheet("QPushButton{border:0px;border-radius:4px;background:transparent;}"
//                                "QPushButton:Hover{border:0px;border-radius:4px;background:transparent;background-color:rgba(0,0,0,0.1);}"
//                                "QPushButton:Pressed{border:0px;border-radius:4px;background:transparent;background-color:rgba(0,0,0,0.15);}"
//                                "QPushButton::menu-indicator{image:None;}");
//    btnMinimize->setStyleSheet("QPushButton{border:0px;border-radius:4px;background:transparent;}"
//                               "QPushButton:Hover{border:0px;border-radius:4px;background:transparent;background-color:rgba(0,0,0,0.1);}"
//                               "QPushButton:Pressed{border:0px;border-radius:4px;background:transparent;background-color:rgba(0,0,0,0.15);}");
//    btnCancel->setStyleSheet("QPushButton{border:0px;border-radius:4px;background:transparent;}"
//                             "QPushButton:Hover{border:0px;border-radius:4px;background:transparent;background-color:#F86457;}"
//                             "QPushButton:Pressed{border:0px;border-radius:4px;background:transparent;background-color:#E44C50;}");
}

//bool title::eventFilter(QObject *watched, QEvent *event)
//{
//    if(watched == this)
//    {
//        if (event->type() == QEvent::MouseButtonDblClick)           //判断类型
//        {
//            QMouseEvent *mouseEvent = static_cast<QMouseEvent *>(event);
//            if (mouseEvent->button() == Qt::LeftButton) //判断左键
//            {
//                Widget::mutual->slotShowMaximized();
//            }
//        }
//    }
//    return QWidget::eventFilter(watched,event);
//}

