#include "washcar.h"
#include <QVBoxLayout>
#include <QGraphicsOpacityEffect>
#define UKUI_STYLE "org.ukui.style"
#define UKUI_FONT_SIZE "systemFontSize"
washcar::washcar(QWidget *parent) : QWidget(parent)
{
    m_washcarLayout = new QVBoxLayout(this);

    m_washcarIcon = new QLabel(this);
    m_str = new QLabel(this);
    m_degree = new QLabel(this);

    QPixmap washcarpixmap(":/res/contorl_icons/index_cash_wash.png");
    m_washcarIcon->setPixmap(washcarpixmap);

    m_str->setText(tr("Wash Car"));

    m_degree->setText("N/A");

    initLayout();
//    initQss();
}

void washcar::setItemContent(QString text)
{
    m_degree->setText(text);
}

void washcar::isFullScreen(int m_isFullScreen)
{
    m_judgeFullScreen = m_isFullScreen;
    initQss(14.0);
}

void washcar::initLayout()
{
    m_washcarLayout->addWidget(m_washcarIcon);
    m_washcarLayout->addWidget(m_str);
    m_washcarLayout->addWidget(m_degree);
}

void washcar::lable2SetFontSizeSlot(int size)
{
    //默认大小12px,换算成pt为9
    double lable2BaseFontSize = 11;//魔鬼数字，自行处理
    double nowFontSize = lable2BaseFontSize * double(size) / 11;//11为系统默认大小，魔鬼数字，自行处理
//    QFont font;
//    font.setPointSizeF(nowFontSize);
//    ui->label2->setFont(font);
    initQss(nowFontSize);
}

void washcar::initFontSize()
{
    //只有非标准字号的控件才需要绑定
    connect(this,&washcar::setFontSizeSignal,this,&washcar::lable2SetFontSizeSlot);

    //判断gsettings是否存在
    if(QGSettings::isSchemaInstalled(UKUI_STYLE)) {
        m_fontSize = new QGSettings(UKUI_STYLE);
        //监听系统字号大小改变事件
        connect(m_fontSize,&QGSettings::changed,this, [=] (const QString &key) {
            if(key == UKUI_FONT_SIZE) {
                //获取字号的值
                int fontSizeKey = m_fontSize->get(UKUI_FONT_SIZE).toString().toInt();
                //发送改变信号
                if (fontSizeKey > 0) {
                    emit setFontSizeSignal(fontSizeKey);
                }
            }
        });
    }
    //启动时设置字号
    int fontSizeKey = 11;//系统默认字号,魔鬼数字，自行处理
    if (m_fontSize != nullptr) {
        int fontSizeKeyTmp = m_fontSize->get(UKUI_FONT_SIZE).toString().toInt();
        if (fontSizeKeyTmp > 0) {
            fontSizeKey = fontSizeKeyTmp;
        }
    }
    emit setFontSizeSignal(fontSizeKey);
}

void washcar::initQss(double nowFontSize)
{
    m_washcarIcon->setAlignment(Qt::AlignCenter);
    if(m_judgeFullScreen == 0){
        m_washcarIcon->resize(30,30);
        QPixmap washcarpixmap(washcarpath);
        m_washcarIcon->setPixmap(washcarpixmap);

        //    m_str->setStyleSheet("font:14px;color:white;");
        QFont m_font;
//        m_font.setPointSizeF(nowFontSize);
        m_str->setFont(m_font);
        m_str->setAlignment(Qt::AlignCenter);
        QPalette washcarStrPalette = m_str->palette();
        washcarStrPalette.setColor(QPalette::WindowText,Qt::white);
        m_str->setPalette(washcarStrPalette);
        //    设置字体透明度
        QGraphicsOpacityEffect *washcarOpacityEffect=new QGraphicsOpacityEffect;
        washcarOpacityEffect->setOpacity(0.7);
        m_str->setGraphicsEffect(washcarOpacityEffect);
        //    m_degree->setStyleSheet("font:14px;color:white;");
        m_degree->setAlignment(Qt::AlignCenter);
        QPalette washcarDegreePalette = m_degree->palette();
        washcarDegreePalette.setColor(QPalette::WindowText,Qt::white);
        m_degree->setPalette(washcarDegreePalette);
        m_degree->setFont(m_font);
    }
    else {
        m_washcarIcon->resize(60,60);
        QPixmap washcarpixmap(washcarpath);
        washcarpixmap = washcarpixmap.scaled(m_washcarIcon->width(),m_washcarIcon->height(),Qt::KeepAspectRatio, Qt::SmoothTransformation);
        m_washcarIcon->setPixmap(washcarpixmap);

        QFont m_font;
        m_font.setPixelSize(28);
        m_str->setFont(m_font);
        m_degree->setFont(m_font);
    }
}
