#include "weekweather.h"
#include <iostream>
#include <QString>
#include <QVector>
#include <QTime>
weekweather::weekweather(QWidget *parent) : QWidget(parent)
{
    m_weekweatherLayout = new QHBoxLayout(this);

    m_onedayweatherfirst = new onedayweather(this);
    m_splitlinefirst = new splitline(this);
    m_onedayweathertwo = new onedayweather(this);
    m_splitlinetwo = new splitline(this);
    m_onedayweatherthree = new onedayweather(this);
    m_splitlinethree = new splitline(this);
    m_onedayweatherfour = new onedayweather(this);
    m_splitlinefour = new splitline(this);
    m_onedayweatherfive = new onedayweather(this);
    m_splitlinefive = new splitline(this);
    m_onedayweathersix = new onedayweather(this);
    m_splitlinesix = new splitline(this);
    m_onedayweatherseven = new onedayweather(this);

    initLayout();
    initConnect();
    initQss();
    //    setDayOfWeekAndDate();
}

void weekweather::setDayOfWeekAndDate()
{
    //    m_onedayweatherfirst->m_dayOfWeek->setText(tr("Today"));
    QLocale localeSystemLanguage = QLocale::system().language(); //指定中文显示
    QString weekOfTwo =
        QString(localeSystemLanguage.toString(QDateTime::currentDateTime().addDays(1), QString("dddd")));
    QString weekOfThree =
        QString(localeSystemLanguage.toString(QDateTime::currentDateTime().addDays(2), QString("dddd")));
    QString weekOfFour =
        QString(localeSystemLanguage.toString(QDateTime::currentDateTime().addDays(3), QString("dddd")));
    QString weekOfFive =
        QString(localeSystemLanguage.toString(QDateTime::currentDateTime().addDays(4), QString("dddd")));
    QString weekOfSix =
        QString(localeSystemLanguage.toString(QDateTime::currentDateTime().addDays(5), QString("dddd")));
    QString weekOfSeven =
        QString(localeSystemLanguage.toString(QDateTime::currentDateTime().addDays(6), QString("dddd")));

    m_onedayweathertwo->m_dayOfWeek->setText(weekOfTwo);
    m_onedayweatherthree->m_dayOfWeek->setText(weekOfThree);
    m_onedayweatherfour->m_dayOfWeek->setText(weekOfFour);
    m_onedayweatherfive->m_dayOfWeek->setText(weekOfFive);
    m_onedayweathersix->m_dayOfWeek->setText(weekOfSix);
    m_onedayweatherseven->m_dayOfWeek->setText(weekOfSeven);

    QDateTime datetime = QDateTime::currentDateTime(); //获取系统现在的时间

    QString m_monthFirst = datetime.toString("MM");
    QString m_monthTwo = datetime.addDays(1).toString("MM");
    QString m_monthThree = datetime.addDays(2).toString("MM");
    QString m_monthFour = datetime.addDays(3).toString("MM");
    QString m_monthFive = datetime.addDays(4).toString("MM");
    QString m_monthSix = datetime.addDays(5).toString("MM");
    QString m_monthSeven = datetime.addDays(6).toString("MM");
    QString m_dateFirst = datetime.toString("dd");
    QString m_dateTwo = datetime.addDays(1).toString("dd");
    QString m_dateThree = datetime.addDays(2).toString("dd");
    QString m_dateFour = datetime.addDays(3).toString("dd");
    QString m_dateFive = datetime.addDays(4).toString("dd");
    QString m_dateSix = datetime.addDays(5).toString("dd");
    QString m_dateSeven = datetime.addDays(6).toString("dd");

    if ("0" == m_monthFirst.mid(0, 1)) {
        m_monthFirst = m_monthFirst.mid(1, 1);
    }
    if ("0" == m_dateFirst.mid(0, 1)) {
        m_dateFirst = m_dateFirst.mid(1, 1);
    }

    if ("0" == m_monthTwo.mid(0, 1)) {
        m_monthTwo = m_monthTwo.mid(1, 1);
    }
    if ("0" == m_dateTwo.mid(0, 1)) {
        m_dateTwo = m_dateTwo.mid(1, 1);
    }

    if ("0" == m_monthThree.mid(0, 1)) {
        m_monthThree = m_monthThree.mid(1, 1);
    }
    if ("0" == m_dateThree.mid(0, 1)) {
        m_dateThree = m_dateThree.mid(1, 1);
    }

    if ("0" == m_monthFour.mid(0, 1)) {
        m_monthFour = m_monthFour.mid(1, 1);
    }
    if ("0" == m_dateFour.mid(0, 1)) {
        m_dateFour = m_dateFour.mid(1, 1);
    }

    if ("0" == m_monthFive.mid(0, 1)) {
        m_monthFive = m_monthFive.mid(1, 1);
    }
    if ("0" == m_dateFive.mid(0, 1)) {
        m_dateFive = m_dateFive.mid(1, 1);
    }

    if ("0" == m_monthSix.mid(0, 1)) {
        m_monthSix = m_monthSix.mid(1, 1);
    }
    if ("0" == m_dateSix.mid(0, 1)) {
        m_dateSix = m_dateSix.mid(1, 1);
    }

    if ("0" == m_monthSeven.mid(0, 1)) {
        m_monthSeven = m_monthSeven.mid(1, 1);
    }
    if ("0" == m_dateSeven.mid(0, 1)) {
        m_dateSeven = m_dateSeven.mid(1, 1);
    }

    QString locale = QLocale::system().name();
    if (locale == "zh_CN") //中文
    {
        // 第 1 天
        QString monthAndDateFirst = m_monthFirst + "月" + m_dateFirst + "日";
        m_onedayweatherfirst->m_date->setText(monthAndDateFirst);
        // 第 2 天
        QString monthAndDateTwo = m_monthTwo + "月" + m_dateTwo + "日";
        m_onedayweathertwo->m_date->setText(monthAndDateTwo);
        // 第 3 天
        QString monthAndDateThree = m_monthThree + "月" + m_dateThree + "日";
        m_onedayweatherthree->m_date->setText(monthAndDateThree);
        // 第 4 天
        QString monthAndDateFour = m_monthFour + "月" + m_dateFour + "日";
        m_onedayweatherfour->m_date->setText(monthAndDateFour);
        // 第 5 天
        QString monthAndDateFive = m_monthFive + "月" + m_dateFive + "日";
        m_onedayweatherfive->m_date->setText(monthAndDateFive);
        // 第 6 天
        QString monthAndDateSix = m_monthSix + "月" + m_dateSix + "日";
        m_onedayweathersix->m_date->setText(monthAndDateSix);
        // 第 7 天
        QString monthAndDateSeven = m_monthSeven + "月" + m_dateSeven + "日";
        m_onedayweatherseven->m_date->setText(monthAndDateSeven);
    } else //非中文
    {
        //第 1 天
        m_onedayweatherfirst->m_date->setText(m_monthFirst + "-" + m_dateFirst);
        // 第 2 天
        m_onedayweathertwo->m_date->setText(m_monthTwo + "-" + m_dateTwo);
        // 第 3 天
        m_onedayweatherthree->m_date->setText(m_monthThree + "-" + m_dateThree);
        // 第 4 天
        m_onedayweatherfour->m_date->setText(m_monthFour + "-" + m_dateFour);
        // 第 5 天
        m_onedayweatherfive->m_date->setText(m_monthFive + "-" + m_dateFive);
        // 第 6 天
        m_onedayweathersix->m_date->setText(m_monthSix + "-" + m_dateSix);
        // 第 7 天
        m_onedayweatherseven->m_date->setText(m_monthSeven + "-" + m_dateSeven);
    }
}

void weekweather::getForcastInfor(ForecastWeather m_forecastWeather, int m_isFullScreen)
{
    forecastWeather = m_forecastWeather;
    // 第 1 天
    QString firstWeather;
    QTime current_time = QTime::currentTime();
    int hour = current_time.hour();
    if (hour >= 6 && hour <= 18) {
        firstWeather = m_forecastWeather.first.cond_txt_d;
        if (m_isFullScreen == 0) // 普通界面
        {
            firstIconPath = ":/res/weather-icon/PNG16/2x/" + m_forecastWeather.first.cond_code_d + ".png";
        } else // 全屏界面
        {
            firstIconPath = ":/res/weather-icon/PNG48/1x/" + m_forecastWeather.first.cond_code_d + ".png";
        }
    } else {
        firstWeather = m_forecastWeather.first.cond_txt_n;
        if (m_isFullScreen == 0) // 普通界面
        {
            firstIconPath = ":/res/weather-icon/PNG16/2x/" + m_forecastWeather.first.cond_code_n + ".png";
        } else // 全屏界面
        {
            firstIconPath = ":/res/weather-icon/PNG48/1x/" + m_forecastWeather.first.cond_code_n + ".png";
        }
    }
    m_onedayweatherfirst->m_weatherIcon->setPixmap(QPixmap(firstIconPath));
    m_onedayweatherfirst->m_temp->setText(m_forecastWeather.first.tmp_min + "°~" + m_forecastWeather.first.tmp_max
                                          + "°");
    m_onedayweatherfirst->m_weather->setText(firstWeather);
    m_onedayweatherfirst->m_wind->setText(m_forecastWeather.first.wind_dir);

    m_onedayweatherfirst->m_date->setText(m_forecastWeather.first.date);
    QDateTime timeFirst;
    timeFirst = QDateTime::fromString(m_forecastWeather.first.date, "yyyy-MM-dd");
    if (timeFirst.toString("MM") == "" || timeFirst.toString("dd") == "") {
        m_onedayweatherfirst->m_date->setText("N/A");
        m_onedayweatherfirst->m_dayOfWeek->setText("N/A");
    } else {
        QString monthFirst = timeFirst.toString("MM");
        QString dateFirst = timeFirst.toString("dd");
        if ("0" == monthFirst.mid(0, 1)) {
            monthFirst = monthFirst.mid(1, 1);
        }
        if ("0" == dateFirst.mid(0, 1)) {
            dateFirst = dateFirst.mid(1, 1);
        }
        m_onedayweatherfirst->m_date->setText(monthFirst + tr("-") + dateFirst + tr(" "));
        m_onedayweatherfirst->m_dayOfWeek->setText(tr("Today"));
    }





    // 第 2 天
    QString twoWeather;
    if (hour >= 6 && hour <= 18) { // 白天
        twoWeather = m_forecastWeather.second.cond_txt_d;
        if (m_isFullScreen == 0) // 普通界面
            twoIconPath = ":/res/weather-icon/PNG16/2x/" + m_forecastWeather.second.cond_code_d + ".png";
        else // 全屏界面
            twoIconPath = ":/res/weather-icon/PNG48/1x/" + m_forecastWeather.second.cond_code_d + ".png";
    } else { // 晚上
        twoWeather = m_forecastWeather.second.cond_txt_n;
        if (m_isFullScreen == 0) // 普通界面
            twoIconPath = ":/res/weather-icon/PNG16/2x/" + m_forecastWeather.second.cond_code_n + ".png";
        else // 全屏界面
            twoIconPath = ":/res/weather-icon/PNG48/1x/" + m_forecastWeather.second.cond_code_n + ".png";
    }
    m_onedayweathertwo->m_weatherIcon->setPixmap(QPixmap(twoIconPath));
    m_onedayweathertwo->m_temp->setText(m_forecastWeather.second.tmp_min + "°~" + m_forecastWeather.second.tmp_max
                                        + "°");
    m_onedayweathertwo->m_weather->setText(twoWeather);
    m_onedayweathertwo->m_wind->setText(m_forecastWeather.second.wind_dir);

    m_onedayweathertwo->m_date->setText(m_forecastWeather.second.date);
    QDateTime timeSecond;
    timeSecond = QDateTime::fromString(m_forecastWeather.second.date, "yyyy-MM-dd");
    if (timeSecond.toString("MM") == "" || timeSecond.toString("dd") == "") {
        m_onedayweathertwo->m_date->setText("N/A");
        m_onedayweathertwo->m_dayOfWeek->setText("N/A");
    } else {
        QString monthTwo = timeSecond.toString("MM");
        QString dateTwo = timeSecond.toString("dd");

        if ("0" == monthTwo.mid(0, 1)) {
            monthTwo = monthTwo.mid(1, 1);
        }
        if ("0" == dateTwo.mid(0, 1)) {
            dateTwo = dateTwo.mid(1, 1);
        }

        m_onedayweathertwo->m_date->setText(monthTwo + tr("-") + dateTwo + tr(" "));
        m_onedayweathertwo->m_dayOfWeek->setText(timeSecond.toString("dddd"));
    }

    // 第 3 天
    QString threeWeather;
    if (hour >= 6 && hour <= 18) {
        threeWeather = m_forecastWeather.third.cond_txt_d;
        if (m_isFullScreen == 0) // 普通界面
            threeIconPath = ":/res/weather-icon/PNG16/2x/" + m_forecastWeather.third.cond_code_d + ".png";
        else
            threeIconPath = ":/res/weather-icon/PNG48/1x/" + m_forecastWeather.third.cond_code_d + ".png";
    } else {
        threeWeather = m_forecastWeather.third.cond_txt_n;
        if (m_isFullScreen == 0) // 普通界面
            threeIconPath = ":/res/weather-icon/PNG16/2x/" + m_forecastWeather.third.cond_code_n + ".png";
        else
            threeIconPath = ":/res/weather-icon/PNG48/1x/" + m_forecastWeather.third.cond_code_n + ".png";
    }
    m_onedayweatherthree->m_weatherIcon->setPixmap(QPixmap(threeIconPath));
    m_onedayweatherthree->m_temp->setText(m_forecastWeather.third.tmp_min + "°~" + m_forecastWeather.third.tmp_max
                                          + "°");
    m_onedayweatherthree->m_weather->setText(threeWeather);
    m_onedayweatherthree->m_wind->setText(m_forecastWeather.third.wind_dir);

    m_onedayweatherthree->m_date->setText(m_forecastWeather.third.date);
    QDateTime timeThird;
    timeThird = QDateTime::fromString(m_forecastWeather.third.date, "yyyy-MM-dd");
    if (timeThird.toString("MM") == "" || timeThird.toString("dd") == "") {
        m_onedayweatherthree->m_date->setText("N/A");
        m_onedayweatherthree->m_dayOfWeek->setText("N/A");
    } else {
        QString monthThree = timeThird.toString("MM");
        QString dateThree = timeThird.toString("MM");
        if ("0" == monthThree.mid(0, 1)) {
            monthThree = monthThree.mid(1, 1);
        }
        if ("0" == dateThree.mid(0, 1)) {
            dateThree = dateThree.mid(1, 1);
        }
        m_onedayweatherthree->m_date->setText(monthThree + tr("-") + dateThree + tr(" "));
        m_onedayweatherthree->m_dayOfWeek->setText(timeThird.toString("dddd"));
    }

    // 第 4 天
    QString fourWeather;
    if (hour >= 6 && hour <= 18) {
        fourWeather = m_forecastWeather.fourth.cond_txt_d;
        if (m_isFullScreen == 0) // 普通界面
            fourIconPath = ":/res/weather-icon/PNG16/2x/" + m_forecastWeather.fourth.cond_code_d + ".png";
        else
            fourIconPath = ":/res/weather-icon/PNG48/1x/" + m_forecastWeather.fourth.cond_code_d + ".png";
    } else {
        fourWeather = m_forecastWeather.fourth.cond_txt_n;
        if (m_isFullScreen == 0) // 普通界面
            fourIconPath = ":/res/weather-icon/PNG16/2x/" + m_forecastWeather.fourth.cond_code_n + ".png";
        else
            fourIconPath = ":/res/weather-icon/PNG48/1x/" + m_forecastWeather.fourth.cond_code_n + ".png";
    }
    m_onedayweatherfour->m_weatherIcon->setPixmap(QPixmap(fourIconPath));
    m_onedayweatherfour->m_temp->setText(m_forecastWeather.fourth.tmp_min + "°~" + m_forecastWeather.fourth.tmp_max
                                         + "°");
    m_onedayweatherfour->m_weather->setText(fourWeather);
    m_onedayweatherfour->m_wind->setText(m_forecastWeather.fourth.wind_dir);

    m_onedayweatherfour->m_date->setText(m_forecastWeather.fourth.date);
    QDateTime timeFourth;
    timeFourth = QDateTime::fromString(m_forecastWeather.fourth.date, "yyyy-MM-dd");
    if (timeFourth.toString("MM") == "" || timeFourth.toString("dd") == "") {
        m_onedayweatherfour->m_date->setText("N/A");
        m_onedayweatherfour->m_dayOfWeek->setText("N/A");
    } else {
        QString monthFour = timeFourth.toString("MM");
        QString dateFour = timeFourth.toString("dd");
        if ("0" == monthFour.mid(0, 1)) {
            monthFour = monthFour.mid(1, 1);
        }
        if ("0" == dateFour.mid(0, 1)) {
            dateFour = dateFour.mid(1, 1);
        }
        m_onedayweatherfour->m_date->setText(monthFour + tr("-") + dateFour + tr(" "));
        m_onedayweatherfour->m_dayOfWeek->setText(timeFourth.toString("dddd"));
    }
    // 第 5 天
    QString fiveWeather;
    if (hour >= 6 && hour <= 18) {
        fiveWeather = m_forecastWeather.fifth.cond_txt_d;
        if (m_isFullScreen == 0) // 普通界面
            fiveIconPath = ":/res/weather-icon/PNG16/2x/" + m_forecastWeather.fifth.cond_code_d + ".png";
        else
            fiveIconPath = ":/res/weather-icon/PNG48/1x/" + m_forecastWeather.fifth.cond_code_d + ".png";
    } else {
        fiveWeather = m_forecastWeather.fifth.cond_txt_n;
        if (m_isFullScreen == 0) // 普通界面
            fiveIconPath = ":/res/weather-icon/PNG16/2x/" + m_forecastWeather.fifth.cond_code_n + ".png";
        else
            fiveIconPath = ":/res/weather-icon/PNG48/1x/" + m_forecastWeather.fifth.cond_code_n + ".png";
    }
    m_onedayweatherfive->m_weatherIcon->setPixmap(QPixmap(fiveIconPath));
    m_onedayweatherfive->m_temp->setText(m_forecastWeather.fifth.tmp_min + "°~" + m_forecastWeather.fifth.tmp_max
                                         + "°");
    m_onedayweatherfive->m_weather->setText(fiveWeather);
    m_onedayweatherfive->m_wind->setText(m_forecastWeather.fifth.wind_dir);


    m_onedayweatherfive->m_date->setText(m_forecastWeather.fifth.date);
    QDateTime timeFifth;
    timeFifth = QDateTime::fromString(m_forecastWeather.fifth.date, "yyyy-MM-dd");
    if (timeFifth.toString("MM") == "" || timeThird.toString("dd") == "") {
        m_onedayweatherfive->m_date->setText("N/A");
        m_onedayweatherfive->m_dayOfWeek->setText("N/A");
    } else {
        QString monthFive = timeFifth.toString("MM");
        QString dateFive = timeFifth.toString("dd");
        if ("0" == monthFive.mid(0, 1)) {
            monthFive = monthFive.mid(1, 1);
        }
        if ("0" == dateFive.mid(0, 1)) {
            dateFive = dateFive.mid(1, 1);
        }
        m_onedayweatherfive->m_date->setText(monthFive + tr("-") + dateFive + tr(" "));
        m_onedayweatherfive->m_dayOfWeek->setText(timeFifth.toString("dddd"));
    }
    // 第 6 天
    QString sixWeather;
    if (hour >= 6 && hour <= 18) {
        sixWeather = m_forecastWeather.sixth.cond_txt_d;
        if (m_isFullScreen == 0) // 普通界面
            sixIconPath = ":/res/weather-icon/PNG16/2x/" + m_forecastWeather.sixth.cond_code_d + ".png";
        else
            sixIconPath = ":/res/weather-icon/PNG48/1x/" + m_forecastWeather.sixth.cond_code_d + ".png";
    } else {
        sixWeather = m_forecastWeather.sixth.cond_txt_n;
        if (m_isFullScreen == 0) // 普通界面
            sixIconPath = ":/res/weather-icon/PNG16/2x/" + m_forecastWeather.sixth.cond_code_n + ".png";
        else
            sixIconPath = ":/res/weather-icon/PNG48/1x/" + m_forecastWeather.sixth.cond_code_n + ".png";
    }
    m_onedayweathersix->m_weatherIcon->setPixmap(QPixmap(sixIconPath));
    m_onedayweathersix->m_temp->setText(m_forecastWeather.sixth.tmp_min + "°~" + m_forecastWeather.sixth.tmp_max + "°");
    m_onedayweathersix->m_weather->setText(sixWeather);
    m_onedayweathersix->m_wind->setText(m_forecastWeather.sixth.wind_dir);

    m_onedayweathersix->m_date->setText(m_forecastWeather.sixth.date);
    QDateTime timeSixth;
    timeSixth = QDateTime::fromString(m_forecastWeather.sixth.date, "yyyy-MM-dd");
    if (timeSixth.toString("MM") == "" || timeSixth.toString("dd") == "") {
        m_onedayweathersix->m_date->setText("N/A");
        m_onedayweathersix->m_dayOfWeek->setText("N/A");
    } else {
        QString monthSix = timeSixth.toString("MM");
        QString dateSix = timeSixth.toString("dd");
        if ("0" == monthSix.mid(0, 1)) {
            monthSix = monthSix.mid(1, 1);
        }
        if ("0" == dateSix.mid(0, 1)) {
            dateSix = dateSix.mid(1, 1);
        }
        m_onedayweathersix->m_date->setText(monthSix + tr("-") + dateSix + tr(" "));
        m_onedayweathersix->m_dayOfWeek->setText(timeSixth.toString("dddd"));
    }


    // 第 7 天
    QString sevenWeather;
    if (hour >= 6 && hour <= 18) {
        sevenWeather = m_forecastWeather.seventh.cond_txt_d;
        if (m_isFullScreen == 0) // 普通界面
            sevenIconPath = ":/res/weather-icon/PNG16/2x/" + m_forecastWeather.seventh.cond_code_d + ".png";
        else
            sevenIconPath = ":/res/weather-icon/PNG48/1x/" + m_forecastWeather.seventh.cond_code_d + ".png";
    } else {
        sevenWeather = m_forecastWeather.seventh.cond_txt_n;
        if (m_isFullScreen == 0) // 普通界面
            sevenIconPath = ":/res/weather-icon/PNG16/2x/" + m_forecastWeather.seventh.cond_code_n + ".png";
        else
            sevenIconPath = ":/res/weather-icon/PNG48/1x/" + m_forecastWeather.seventh.cond_code_n + ".png";
    }
    m_onedayweatherseven->m_weatherIcon->setPixmap(QPixmap(sevenIconPath));
    m_onedayweatherseven->m_temp->setText(m_forecastWeather.seventh.tmp_min + "°~" + m_forecastWeather.seventh.tmp_max
                                          + "°");
    m_onedayweatherseven->m_weather->setText(sevenWeather);
    m_onedayweatherseven->m_wind->setText(m_forecastWeather.seventh.wind_dir);

    m_onedayweatherseven->m_date->setText(m_forecastWeather.seventh.date);
    QDateTime timeSeventh;
    timeSeventh = QDateTime::fromString(m_forecastWeather.seventh.date, "yyyy-MM-dd");
    if (timeSeventh.toString("MM") == "" || timeSeventh.toString("dd") == "") {
        m_onedayweatherseven->m_date->setText("N/A");
        m_onedayweatherseven->m_dayOfWeek->setText("N/A");
    } else {
        QString monthSeven = timeSeventh.toString("MM");
        QString dateSeven = timeSeventh.toString("dd");
        if ("0" == monthSeven.mid(0, 1)) {
            monthSeven = monthSeven.mid(1, 1);
        }
        if ("0" == dateSeven.mid(0, 1)) {
            dateSeven = dateSeven.mid(1, 1);
        }
        m_onedayweatherseven->m_date->setText(monthSeven + tr("-") + dateSeven + tr(" "));
        m_onedayweatherseven->m_dayOfWeek->setText(timeSeventh.toString("dddd"));
    }
}

void weekweather::setWeatherIcon(int m_isFullScreen)
{
    if (m_isFullScreen == 0) {
        firstIconPath = ":/res/weather-icon/PNG16/2x/" + forecastWeather.first.cond_code_d + ".png";
        twoIconPath = ":/res/weather-icon/PNG16/2x/" + forecastWeather.second.cond_code_d + ".png";
        threeIconPath = ":/res/weather-icon/PNG16/2x/" + forecastWeather.third.cond_code_d + ".png";
        fourIconPath = ":/res/weather-icon/PNG16/2x/" + forecastWeather.fourth.cond_code_d + ".png";
        fiveIconPath = ":/res/weather-icon/PNG16/2x/" + forecastWeather.fifth.cond_code_d + ".png";
        sixIconPath = ":/res/weather-icon/PNG16/2x/" + forecastWeather.sixth.cond_code_d + ".png";
        sevenIconPath = ":/res/weather-icon/PNG16/2x/" + forecastWeather.seventh.cond_code_d + ".png";

        m_onedayweatherfirst->m_weatherIcon->resize(36, 33);
        m_onedayweatherfirst->m_weatherIcon->setPixmap(QPixmap(firstIconPath));
        m_onedayweathertwo->m_weatherIcon->resize(36, 33);
        m_onedayweathertwo->m_weatherIcon->setPixmap(QPixmap(twoIconPath));
        m_onedayweatherthree->m_weatherIcon->resize(36, 33);
        m_onedayweatherthree->m_weatherIcon->setPixmap(QPixmap(threeIconPath));
        m_onedayweatherfour->m_weatherIcon->resize(36, 33);
        m_onedayweatherfour->m_weatherIcon->setPixmap(QPixmap(fourIconPath));
        m_onedayweatherfive->m_weatherIcon->resize(36, 33);
        m_onedayweatherfive->m_weatherIcon->setPixmap(QPixmap(fiveIconPath));
        m_onedayweathersix->m_weatherIcon->resize(36, 33);
        m_onedayweathersix->m_weatherIcon->setPixmap(QPixmap(sixIconPath));
        m_onedayweatherseven->m_weatherIcon->resize(36, 33);
        m_onedayweatherseven->m_weatherIcon->setPixmap(QPixmap(sevenIconPath));
    } else {
        firstIconPath = ":/res/weather-icon/PNG48/1x/" + forecastWeather.first.cond_code_d + ".png";
        twoIconPath = ":/res/weather-icon/PNG48/1x/" + forecastWeather.second.cond_code_d + ".png";
        threeIconPath = ":/res/weather-icon/PNG48/1x/" + forecastWeather.third.cond_code_d + ".png";
        fourIconPath = ":/res/weather-icon/PNG48/1x/" + forecastWeather.fourth.cond_code_d + ".png";
        fiveIconPath = ":/res/weather-icon/PNG48/1x/" + forecastWeather.fifth.cond_code_d + ".png";
        sixIconPath = ":/res/weather-icon/PNG48/1x/" + forecastWeather.sixth.cond_code_d + ".png";
        sevenIconPath = ":/res/weather-icon/PNG48/1x/" + forecastWeather.seventh.cond_code_d + ".png";

        m_onedayweathertwo->m_weatherIcon->resize(72, 66);
        QPixmap twopixmap(twoIconPath);
        twopixmap =
            twopixmap.scaled(m_onedayweathertwo->m_weatherIcon->width(), m_onedayweathertwo->m_weatherIcon->height(),
                             Qt::IgnoreAspectRatio, Qt::SmoothTransformation);
        m_onedayweathertwo->m_weatherIcon->setPixmap(twopixmap);

        m_onedayweatherthree->m_weatherIcon->resize(72, 66);
        QPixmap threepixmap(threeIconPath);
        threepixmap = twopixmap.scaled(m_onedayweatherthree->m_weatherIcon->width(),
                                       m_onedayweatherthree->m_weatherIcon->height(), Qt::IgnoreAspectRatio,
                                       Qt::SmoothTransformation);
        m_onedayweatherthree->m_weatherIcon->setPixmap(threepixmap);

        m_onedayweatherfour->m_weatherIcon->resize(72, 66);
        QPixmap fourpixmap(fourIconPath);
        fourpixmap =
            fourpixmap.scaled(m_onedayweatherfour->m_weatherIcon->width(), m_onedayweatherfour->m_weatherIcon->height(),
                              Qt::IgnoreAspectRatio, Qt::SmoothTransformation);
        m_onedayweatherfour->m_weatherIcon->setPixmap(fourpixmap);

        m_onedayweatherfive->m_weatherIcon->resize(72, 66);
        QPixmap fivepixmap(fiveIconPath);
        fivepixmap =
            fivepixmap.scaled(m_onedayweatherfive->m_weatherIcon->width(), m_onedayweatherfive->m_weatherIcon->height(),
                              Qt::IgnoreAspectRatio, Qt::SmoothTransformation);
        m_onedayweatherfive->m_weatherIcon->setPixmap(fivepixmap);

        m_onedayweathersix->m_weatherIcon->resize(72, 66);
        QPixmap sixpixmap(sixIconPath);
        sixpixmap =
            sixpixmap.scaled(m_onedayweathersix->m_weatherIcon->width(), m_onedayweathersix->m_weatherIcon->height(),
                             Qt::IgnoreAspectRatio, Qt::SmoothTransformation);
        m_onedayweathersix->m_weatherIcon->setPixmap(sixpixmap);

        m_onedayweatherseven->m_weatherIcon->resize(72, 66);
        QPixmap pixmap(sevenIconPath);
        pixmap =
            pixmap.scaled(m_onedayweatherseven->m_weatherIcon->width(), m_onedayweatherseven->m_weatherIcon->height(),
                          Qt::IgnoreAspectRatio, Qt::SmoothTransformation);
        m_onedayweatherseven->m_weatherIcon->setPixmap(pixmap);

        // m_onedayweatherfirst 不能放在第一个设置，显示会发生变形，原因不明
        m_onedayweatherfirst->m_weatherIcon->resize(72, 66);
        QPixmap firstpixmap(firstIconPath);
        firstpixmap =
            firstpixmap.scaled(m_onedayweathertwo->m_weatherIcon->width(), m_onedayweathertwo->m_weatherIcon->height(),
                               Qt::IgnoreAspectRatio, Qt::SmoothTransformation);
        m_onedayweatherfirst->m_weatherIcon->setPixmap(firstpixmap);
    }
}

void weekweather::initLayout()
{
    m_weekweatherLayout->addStretch(4);
    m_weekweatherLayout->addWidget(m_onedayweatherfirst);
    m_weekweatherLayout->addStretch(2);
    m_weekweatherLayout->addWidget(m_splitlinefirst);
    m_weekweatherLayout->addStretch(2);
    m_weekweatherLayout->addWidget(m_onedayweathertwo);
    m_weekweatherLayout->addStretch(2);
    m_weekweatherLayout->addWidget(m_splitlinetwo);
    m_weekweatherLayout->addStretch(2);
    m_weekweatherLayout->addWidget(m_onedayweatherthree);
    m_weekweatherLayout->addStretch(2);
    m_weekweatherLayout->addWidget(m_splitlinethree);
    m_weekweatherLayout->addStretch(2);
    m_weekweatherLayout->addWidget(m_onedayweatherfour);
    m_weekweatherLayout->addStretch(2);
    m_weekweatherLayout->addWidget(m_splitlinefour);
    m_weekweatherLayout->addStretch(2);
    m_weekweatherLayout->addWidget(m_onedayweatherfive);
    m_weekweatherLayout->addStretch(2);
    m_weekweatherLayout->addWidget(m_splitlinefive);
    m_weekweatherLayout->addStretch(2);
    m_weekweatherLayout->addWidget(m_onedayweathersix);
    m_weekweatherLayout->addStretch(2);
    m_weekweatherLayout->addWidget(m_splitlinesix);
    m_weekweatherLayout->addStretch(2);
    m_weekweatherLayout->addWidget(m_onedayweatherseven);
    m_weekweatherLayout->addStretch(4);
    m_weekweatherLayout->setContentsMargins(20, 0, 20, 0);
    this->setLayout(m_weekweatherLayout);
}

void weekweather::initConnect()
{
    connect(this, &weekweather::sendIsFullScreen, m_onedayweatherfirst, &onedayweather::isFullScreen);
    connect(this, &weekweather::sendIsFullScreen, m_onedayweathertwo, &onedayweather::isFullScreen);
    connect(this, &weekweather::sendIsFullScreen, m_onedayweatherthree, &onedayweather::isFullScreen);
    connect(this, &weekweather::sendIsFullScreen, m_onedayweatherfour, &onedayweather::isFullScreen);
    connect(this, &weekweather::sendIsFullScreen, m_onedayweatherfive, &onedayweather::isFullScreen);
    connect(this, &weekweather::sendIsFullScreen, m_onedayweathersix, &onedayweather::isFullScreen);
    connect(this, &weekweather::sendIsFullScreen, m_onedayweatherseven, &onedayweather::isFullScreen);
}

void weekweather::resizeEvent(QResizeEvent *event) {}

void weekweather::initQss()
{
    //    this->setStyleSheet("QWidget{background:blue;}");
    //    this->setStyleSheet("QWidget{background:transparent;}");
}
