#ifndef COLLECTCITY_H
#define COLLECTCITY_H

#include <QObject>
#include <QTableView>
#include <QWidget>
#include <QLabel>
#include <QFrame>
#include <QScrollArea>
#include <QScrollBar>
#include <QHeaderView>
#include "collectitemdelegate.h"
#include "controller/Interaction.h"
class CollectCity : public QWidget
{
    Q_OBJECT
public:
    CollectCity(QWidget *parent = nullptr);
    QLabel *m_noneCity;//列表无城市
    QTableView *m_cityList;//收藏城市列表
    void setModelforView();//设置模型
private:
    void initInteraction();//信号槽--后端信号
    QLabel *m_cityTitle;//收藏城市标题
    CollectItemDelegate *m_delegate = nullptr;//model/view代理
    void initConnect();//信号槽
private slots:
    void changeItem();//收藏城市为空，收藏列表隐藏
    void changeShow();//判断不为空，两个控件的显隐状态

signals:
    void changeCityFromCollect(QModelIndex index);//从收藏城市改变当前城市
    void changeItemPos();//判断为空，改变收藏和热门的位置

};

#endif // COLLECTCITY_H
