#include "collectitemdelegate.h"

CollectItemDelegate::CollectItemDelegate(QWidget *parent): QStyledItemDelegate(parent)
{

}
void CollectItemDelegate::paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
    if(index.isValid())
    {
        QVariant variant = index.data(Qt::UserRole);
        CollectItemData data = variant.value<CollectItemData>();
        QStyleOptionButton* delButton = m_btns.value(index);

        delButton = new QStyleOptionButton();
        delButton->state |= QStyle::State_Enabled;

        if (ViewVar::s_themeStyle) {
          delButton->icon =  QIcon(":/res/contorl_icons/delete_light.png");
        } else {
          delButton->icon =  QIcon(":/res/contorl_icons/delete_dark.png");
        }

        delButton->iconSize = ViewVar::COLLECT_BTNSIZE;

        (const_cast<CollectItemDelegate *>(this))->m_btns.insert(index, delButton);
        painter->save();
        //画圆角
        QRectF rect;
        rect.setX(option.rect.x());//x
        rect.setY(option.rect.y());//y
        rect.setWidth( option.rect.width()-4);//w-4
        rect.setHeight(option.rect.height()-4);//y-4
        const qreal radius = ViewVar::SAME_ITEMRADIUS;//radius
        QPainterPath path;
        path.moveTo(rect.topRight() - QPointF(radius, 0));
        path.lineTo(rect.topLeft() + QPointF(radius, 0));
        path.quadTo(rect.topLeft(), rect.topLeft() + QPointF(0, radius));
        path.lineTo(rect.bottomLeft() + QPointF(0, -radius));
        path.quadTo(rect.bottomLeft(), rect.bottomLeft() + QPointF(radius, 0));
        path.lineTo(rect.bottomRight() - QPointF(radius, 0));
        path.quadTo(rect.bottomRight(), rect.bottomRight() + QPointF(0, -radius));
        path.lineTo(rect.topRight() + QPointF(0, radius));
        path.quadTo(rect.topRight(), rect.topRight() + QPointF(-radius, -0));

        if (option.state & QStyle::State_MouseOver) {
            if (data.cityName == "" || data.tmp == "" || data.cond_code == "") {
                painter->setPen(Qt::NoPen);//去边框
                //设置背景颜色
                painter->setRenderHint(QPainter::Antialiasing);
                painter->drawRoundRect(ViewVar::COLLECT_ITEMRECT);
                painter->setRenderHint(QPainter::Antialiasing);
//                painter->setBrush(ViewVar::s_colorItem);//设置画刷形式
                painter->setOpacity(ViewVar::SAME_OPACITY_0);
                painter->drawPath(path);
            } else {
                painter->setPen(Qt::NoPen);//去边框
                //设置按钮样式
                QPalette btnPal = delButton->palette;
                btnPal.setColor(QPalette::Button, Qt::transparent);//设置按钮的背景颜色
//                btnPal.setColor(QPalette::ButtonText, QColor(255, 255, 255,0));//设置按钮文字颜色
                delButton->palette = btnPal;
                delButton->rect = option.rect.adjusted(ViewVar::COLLECT_BTNXL, ViewVar::COLLECT_BTNYL,ViewVar::COLLECT_BTNXR,ViewVar::COLLECT_BTNYR);//button位置
                //设置背景颜色
                painter->setRenderHint(QPainter::Antialiasing);
                painter->drawRoundRect(ViewVar::COLLECT_ITEMRECT);
                painter->setRenderHint(QPainter::Antialiasing);
//                painter->setBrush(ViewVar::s_colorItem);//设置画刷形式
                painter->setOpacity(ViewVar::SAME_OPACITY_1);
                painter->drawPath(path);
            }
        } else if (option.state & QStyle::State_Selected) {
            if (data.cityName == "" || data.tmp == "" || data.cond_code == "") {
                painter->setPen(Qt::NoPen);//去边框
                //设置背景颜色
                painter->setRenderHint(QPainter::Antialiasing);
                painter->drawRoundRect(ViewVar::COLLECT_ITEMRECT);
                painter->setRenderHint(QPainter::Antialiasing);
//                painter->setBrush(ViewVar::s_colorItem);//设置画刷形式
                painter->setOpacity(ViewVar::SAME_OPACITY_0);
                painter->drawPath(path);
            } else {
                painter->setPen(Qt::NoPen);//去边框
                //设置按钮样式
                QPalette btnPal = delButton->palette;
                btnPal.setColor(QPalette::Button, Qt::transparent);//设置按钮的背景颜色
                //            btnPal.setColor(QPalette::ButtonText, QColor(255, 255, 255,0));//设置按钮文字颜色
                delButton->palette = btnPal;
                delButton->rect = option.rect.adjusted(ViewVar::COLLECT_BTNXL, ViewVar::COLLECT_BTNYL,ViewVar::COLLECT_BTNXR,ViewVar::COLLECT_BTNYR);//button位置
                //设置背景颜色
                painter->setRenderHint(QPainter::Antialiasing);
                painter->drawRoundRect(ViewVar::COLLECT_ITEMRECT);
                painter->setRenderHint(QPainter::Antialiasing);
//                painter->setBrush(ViewVar::s_colorItem);//设置画刷形式
                painter->setOpacity(ViewVar::SAME_OPACITY_1);
                painter->drawPath(path);
            }
        }
        if (!(data.cityName == "" || data.tmp == "" || data.cond_code == "")) {
            painter->setPen(ViewVar::m_collectPen);
            painter->setOpacity(ViewVar::SAME_OPACITY_2);
            QString cityname = data.cityName.mid(0,4);
            if (data.cityName != cityname) {
                cityname = cityname + "...";
            }
            painter->drawText(option.rect.adjusted(ViewVar::COLLECT_NAMEXL, ViewVar::COLLECT_SAMEYL, ViewVar::COLLECT_SAMEXR, ViewVar::COLLECT_SAMEYR), Qt::AlignLeft, cityname); //绘制城市名字
//            painter->drawText(option.rect.adjusted(ViewVar::COLLECT_NAMEXL, ViewVar::COLLECT_SAMEYL, ViewVar::COLLECT_SAMEXR, ViewVar::COLLECT_SAMEYR), Qt::AlignLeft, data.cityName); //绘制城市名字
            painter->drawText(option.rect.adjusted(ViewVar::COLLECT_TMPXL, ViewVar::COLLECT_SAMEYL, ViewVar::COLLECT_SAMEXR, ViewVar::COLLECT_SAMEYR), Qt::AlignLeft, data.tmp);
            //天气图标
            if (data.cond_code == "") {
                painter->drawText(option.rect.adjusted(ViewVar::COLLECT_CODEXL, ViewVar::COLLECT_SAMEYL, ViewVar::COLLECT_SAMEXR, ViewVar::COLLECT_SAMEYR), Qt::AlignLeft, data.cond_code);
            } else {
                QString iconPath = ViewVar::COLLECT_ICONPATH  +  data.cond_code + ViewVar::COLLECT_ICONSUFFIX;
                QPixmap pixmap(iconPath);
                painter->drawPixmap(option.rect.adjusted(ViewVar::COLLECT_ICONXL, ViewVar::COLLECT_ICONYL, ViewVar::COLLECT_ICONXR,ViewVar::COLLECT_ICONYR), pixmap);
            }
        }
        painter->restore();
//        QWidget *pWidget =  m_pOpenButton.data();----备用
        QApplication::style()->drawControl(QStyle::CE_PushButton, delButton, painter);
    }
}

bool CollectItemDelegate::editorEvent(QEvent *event, QAbstractItemModel *model, const QStyleOptionViewItem &option, const QModelIndex &index)
{
    //判断是自动画出的，没有数据的item
    if (model->data(index,Qt::UserRole).isNull()) {
        return true;
    }
    if (event->type() == QEvent::MouseButtonRelease) {
        QMouseEvent* e =(QMouseEvent*)event;
        if (m_btns.contains(index)) {
            QStyleOptionButton* btns = m_btns.value(index);
            if (btns->rect.contains(e->x(), e->y())) {
                btns->state &= (~QStyle::State_Sunken);
                emit delCollectCity(index);
            } else {
                emit changeCityFromCollect(index);
            }
        }
    }
    Q_UNUSED(option);
    return true;
}
