#include "searchbox.h"
SearchBox::SearchBox(QWidget* parent)
    :QLineEdit(parent)
{
    this->setFixedSize(ViewVar::SEARCH_BOX);
    this->setFocusPolicy(Qt::ClickFocus);
    this->setTextMargins(ViewVar::SEARCH_MARGINS);

    m_searchIcon = new SearchBtn(this);
    m_searchIcon->move(ViewVar::SEARCH_ICON_X0,(this->height() - m_searchIcon->height())/2);

    m_searchText = new QLabel(this);
    m_searchText->setText(tr("Search"));
    m_searchText->setFixedWidth(this->width());
    m_searchText->move(m_searchIcon->x() + m_searchIcon->width() + 8,(this->height() - m_searchText->height())/2 +2);
}



void SearchBox::restoreStatus(bool shouldRestore)
{
    m_isShouldRestore = shouldRestore;
}

//处理icon和text位置和显隐
void SearchBox::dealIconText(bool isFoucs)
{
    if (isFoucs) {
        m_searchIcon->move(ViewVar::SEARCH_ICON_X1,(this->height() - m_searchIcon->height())/2);
        m_searchText->hide();
    } else {
        if (!m_isShouldRestore) {
            return;
        }
        this->clear();
        m_searchIcon->move(ViewVar::SEARCH_ICON_X0,(this->height() - m_searchIcon->height())/2);
        m_searchText->show();
        m_searchText->move(m_searchIcon->x() + m_searchIcon->width() + 8,(this->height() - m_searchText->height())/2 +2);
    }
}

void SearchBox::dealUiShow()
{
    this->clear();
    m_searchIcon->move(ViewVar::SEARCH_ICON_X0,(this->height() - m_searchIcon->height())/2);
    m_searchText->show();
    m_searchText->move(m_searchIcon->x() + m_searchIcon->width() + 8,(this->height() - m_searchText->height())/2 +2);
}

bool SearchBox::event(QEvent *e){
    if(e->type() == QEvent::FocusOut){
        m_isFocus = false;
        dealIconText(m_isFocus);
        return QLineEdit::event(e);
    } else if(e->type() == QEvent::FocusIn)
    {
        m_isFocus = true;
        dealIconText(m_isFocus);
        return QLineEdit::event(e);
    }

    return QLineEdit::event(e);
}


