#ifndef SEARCHBOX_H
#define SEARCHBOX_H

#include <QObject>
#include <QLineEdit>
#include <QPainter>
#include <QGuiApplication>
#include <QDebug>
#include <QMouseEvent>
#include <QPushButton>
#include <QLabel>
#include <QPalette>
#include <QPaintEvent>
#include <QStyleOption>
#include "searchbtn.h"
#include "controller/Interaction.h"
#include "global/viewvar.h"
class SearchBox : public QLineEdit
{
    Q_OBJECT
public:
    explicit SearchBox(QWidget* parent = 0);
    void dealUiShow();//处理当在外部对ui进行交互时的icon和text位置和显隐
signals:

protected:
    bool event(QEvent *event) Q_DECL_OVERRIDE;
private:
    bool m_isFocus = false;//判断焦点是否在搜索框上
    void dealIconText(bool isFoucs);//处理icon和text位置和显隐
    QLabel *m_searchText;//"search"文字显示
    SearchBtn *m_searchIcon;//搜索图片
    bool m_isShouldRestore = true;//判断是否还原状态，默认为true--还原

public slots:
    void restoreStatus(bool shouldRestore);//设置参数，判断是否还原搜索框默认状态

};

#endif // SEARCHBOX_H
