#ifndef SEARCHVIEW_H
#define SEARCHVIEW_H

#include <QWidget>
#include <QLineEdit>
#include <QDialog>
#include <QPainter>
#include <QDebug>
#include <QLabel>
#include <QPushButton>
#include "searchbox.h"
#include "hotcity.h"
#include "controller/Interaction.h"
#include "searchcitylist.h"
#include "collectcity.h"

class SearchView : public QWidget
{
    Q_OBJECT
public:
    explicit SearchView(QWidget *parent = nullptr);
    void changeUiShow();//切换主界面城市时的ui处理
    void searchReset();//重置界面
private:
    void initInteraction();
    SearchBox *m_searchBox = nullptr;
    HotCity *m_hotCity = nullptr;
    QWidget *m_centerWid = nullptr;
    SearchCityLIst *m_searchCityList = nullptr;
    CollectCity *m_collectCity = nullptr;
    QPushButton *m_searchIcon;
    QLabel *m_searchText;

    void changePostion();//确定热门城市和收藏城市位置
    void paintEvent(QPaintEvent *event);
    bool event(QEvent *event);//做searchBox的失焦处理
    void changeCity(QString cityId);//改变当前城市
    void initConnect();


signals:
    void searchWidState();//发送信号，处理点击切换城市后的界面显示
    void shouldRestore(bool isShouldRestore);//发送信号，处理搜索框的显示

private slots:
    void sendSearchInput();//发送搜索内容
    void addCollectCity(QModelIndex index);//添加城市至收藏城市列表
    void changeCityFromSearch(QModelIndex index);//从搜索界面切换主界面城市
    void changeCityFromCollect(QModelIndex index);//从收藏城市列表切换主界面城市
    void searchListUi(bool hasCity);//搜索列表界面控件变化


};

#endif // SEARCHVIEW_H
